POJ3126 Prime Path(BFS)

版权声明:本文为博主原创文章,未经博主允许不得转载。 https://blog.csdn.net/UncleJokerly/article/details/83446243

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 

1033 
1733 
3733 
3739 
3779 
8779 
8179

The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

题意:

给出n和m,要求把n变为m,每次只能变一位上的数字,且每次中间过程的四位数也必须是素数,求最少变化次数。

解题思路:

BFS。遍历四位数字上的每一位即可。

AC代码:

#include<cstdio>
#include<cstring>
#include<queue>
using namespace std;

int n,m;
int book[10010];

struct node
{
	int x,step;
};

node getnode(int x,int step)
{
	node q;
	q.x=x;
	q.step=step;
	return q;
}

int isp(int n)
{
	if(n<=1) return 0;
	else
	{
		for(int i=2;i*i<=n;i++)
		{
			if(n%i==0) return 0;
		}
	}
	return 1;
}

void bfs(int x,int step)
{
	queue<node> q;
	q.push(getnode(x,step));
	while(!q.empty())
	{
		if(q.front().x==m)
		{
			printf("%d\n",q.front().step);
			return;
		}
		int a=q.front().x/1000;
		int b=q.front().x/100%10;
		int c=q.front().x%100/10;
		int d=q.front().x%10;
		//printf("a===%d b===%d c===%d d===%d\n",a,b,c,d);
		for(int i=0;i<=9;i++)
		{
			if(i==a) continue;
			else
			{
				int tx=i*1000+b*100+c*10+d;
				if(tx>=1000&&isp(tx)&&book[tx]==0)
				{
					book[tx]=1;
					q.push(getnode(tx,q.front().step+1));
				}
			}
		}
		
		for(int i=0;i<=9;i++)
		{
			if(i==b) continue;
			else
			{
				int tx=a*1000+i*100+c*10+d;
				if(tx>=1000&&isp(tx)&&book[tx]==0)
				{
					book[tx]=1;
					q.push(getnode(tx,q.front().step+1));
				}
			}
		}
		for(int i=0;i<=9;i++)
		{
			if(i==c) continue;
			else
			{
				int tx=a*1000+b*100+i*10+d;
				if(tx>=1000&&isp(tx)&&book[tx]==0)
				{
					book[tx]=1;
					q.push(getnode(tx,q.front().step+1));
				}
			}
		}
		for(int i=0;i<=9;i++)
		{
			if(i==d) continue;
			else
			{
				int tx=a*1000+b*100+c*10+i;
				if(tx>=1000&&isp(tx)&&book[tx]==0)
				{
					book[tx]=1;
					q.push(getnode(tx,q.front().step+1));
				}
			}
		}
		q.pop();
	}
	printf("Impossible\n");
}

int main()
{
	int t;
	scanf("%d",&t);
	while(t--)
	{
		scanf("%d%d",&n,&m);
		memset(book,0,sizeof(book));
		book[n]=1;
		bfs(n,0);
	}
	return 0;
}

猜你喜欢

转载自blog.csdn.net/UncleJokerly/article/details/83446243